#!/bin/bash
# Server installation script for 
# eDokumenty on Debian Jessie
#
# @version 3.0
# @author: BetaSoft
#

INSTALL_DIR=$(pwd)

echo -ne "\033[01;32mCzy chcesz instalowac pakiety managerem apt-get? Zalecane y (y/n) \033[00m \n"
read APTYESNO
if [ "$APTYESNO" = "y" ]; then

adduser edokumenty sudo

#Dodatkowe repozytorium dla postgresql
cp conf/pgdg.list /etc/apt/sources.list.d/ 
apt-key add lib/ACCC4CF8.asc
sleep 5

apt-get update

# Base tools
apt-get -y install ssh
apt-get -y install mc
apt-get -y install nmap
apt-get -y install ngrep
apt-get -y install sed
apt-get -y install wget
apt-get -y install gzip
apt-get -y install adduser
apt-get -y install useradd
apt-get -y install bzip2
apt-get -y install unzip
apt-get -y install rsync
apt-get -y install less
apt-get -y install rdate
# System tools
apt-get -y install sudo
apt-get -y install cron
apt-get -y install iproute
apt-get -y install tcpdump
apt-get -y install ntpdate 

# Additional tools
apt-get -y install apt-show-versions
apt-get -y install gcc
apt-get -y install g++
apt-get -y install cpp
apt-get -y install make

# Backup tools
apt-get -y install mkisofs
apt-get -y install hdparm
apt-get -y install dvd+rw-tools
apt-get -y install mt-st
apt-get -y install smbfs
apt-get -y install autofs

# Processing tools
apt-get -y install imagemagick
apt-get -y install gs-common
apt-get -y install html2ps
apt-get -y install latex2rtf
apt-get -y install antiword
apt-get -y install gnuhtml2latex
apt-get -y install tesseract-ocr
apt-get -y install tesseract-ocr-pol

# Services
apt-get -y --force-yes install postgresql-9.5
apt-get -y install apache2
apt-get -y install php5
apt-get -y install php5-cli
apt-get -y install php-pear
apt-get -y install php5-pgsql
apt-get -y install php5-imap
apt-get -y install php5-dev
apt-get -y install php5-gd
apt-get -y install php5-sybase
apt-get -y install php5-odbc
apt-get -y install php5-sqlite
apt-get -y install memcached
apt-get -y install php5-memcached
apt-get -y install pgbouncer


apt-get -y install subversion
apt-get -y install openssl
apt-get -y install ssl-cert

apt-get -y install abiword

fi

#Memcache
    cp -p $INSTALL_DIR'/conf/memcached.conf' /etc/


# Postfix
echo -ne "\033[01;32mCzy zainstalowac Postfix? (y/n) \033[00m \n"
read FAXYESNO
if [ "$FAXYESNO" = "y" ]; then
    apt-get install postfix
    apt-get install libsasl2-modules
fi

# Postfix
echo -ne "\033[01;32mCzy zainstalowac Pgbouncer? (y/n) \033[00m \n"
read PGBOUNCER
if [ "$PGBOUNCER" = "y" ]; then
    apt-get install pgbouncer
    cp -p $INSTALL_DIR'/conf/pgbouncer.ini' /etc/pgbouncer
    cp -p $INSTALL_DIR'/conf/userlist.txt' /etc/pgbouncer
fi


# Fax utils
echo -ne "\033[01;32mCzy zainstalowac hylafax server? (y/n) \033[00m \n"
read FAXYESNO
if [ "$FAXYESNO" = "y" ]; then
    apt-get install setserial
    apt-get install ppp
    apt-get install hylafax-server
    apt-get install hylafax-client
    apt-get install wvdial
fi

echo "Zakladanie kont i konfiguracja grup dla edokumenty"
# konta i grupy systemowe
adduser --ingroup users edokumenty 
groupadd edokumenty
adduser edokumenty edokumenty
adduser www-data edokumenty

echo "Aktywacja modulow Apache"
for module in php5 ssl rewrite userdir vhost_alias
do 
    a2enmod $module;
done

#enable ssl
a2ensite default-ssl

# Modyfikacje plików konfiguracyjnych
echo -ne "\033[01;32mCzy modyfikowac pliki konfiguracyjne (zalecane y)? (y/n) \033[00m \n"
read CONFYESNO
if [ "$CONFYESNO" = "y" ]; then

    rm -f /etc/apache2/sites-available/*    
    cp -p $INSTALL_DIR'/conf/default.conf' /etc/apache2/sites-available/
    cp -p $INSTALL_DIR'/conf/default-ssl.conf' /etc/apache2/sites-available/
    cp -p $INSTALL_DIR'/conf/apache2.conf' /etc/apache2/

   # kopiowanie certyfikatow ssl
    cp -p $INSTALL_DIR'/conf/edokumenty.crt' /etc/ssl/certs/
    cp -p $INSTALL_DIR'/conf/edokumenty.key' /etc/ssl/certs/

    # konfiguracja php
    cp -p $INSTALL_DIR'/conf/php.ini' /etc/php5/apache2/
    cp -p $INSTALL_DIR'/conf/php.ini' /etc/php5/cli/
    touch /var/log/php_error.log
    chown www-data:www-data /var/log/php_error.log

    # postgres 9.5
    #cd /etc/postgresql/9.5/main
    cp -p $INSTALL_DIR'/conf/pg_hba.conf' /etc/postgresql/9.5/main/
    cp -p $INSTALL_DIR'/conf/postgresql.conf' /etc/postgresql/9.5/main/
    systemctl enable postgresql
fi

#Synchronizacja Poczty dodaje ramdisk
echo  "tmpfs /home/edokumenty/public_html/apps/backproc/data tmpfs defaults,noatime,nosuid,nodev,noexec,mode=1777,size=64M 0 0" >> /etc/fstab
mount /home/edokumenty/public_html/apps/backproc/data
cd /home/edokumenty/public_html/apps/backproc
chown -R www-data:edokumenty data logs pid
chmod -R u+rwX,g+rwXs,o-rwx data logs pid
echo '*/5 * * * * www-data php /home/edokumenty/public_html/apps/backproc/engine.php 2>&1 &' >> /etc/crontab

#pgbouncer

 cp -p $INSTALL_DIR'/conf/pgbouncer.ini' /etc/pgbouncer/
 cp -p $INSTALL_DIR'/conf/userlist.txt' /etc/pgbouncer/

# Przypisanie tych samych ustawień do php consolowego
rm /etc/php5/cli/php.ini
ln -s /etc/php5/apache2/php.ini /etc/php5/cli/php.ini

# Instalacja dodatkowych modułów
echo -ne "\033[01;32mCzy chcesz instalowac moduly Zendo Optimizer dla php 5.6? (y/n) \033[00m \n"
read CONFYESNO
if [ "$CONFYESNO" = "y" ]; then
    # Zend Optimizer
    echo "Instalacja ZendOptimizer"
    cp   $INSTALL_DIR'/zend/ZendGuardLoader.so' /usr/lib/php5/
    cp   $INSTALL_DIR'/zend/opcache.so' /usr/lib/php5/
fi

echo "Utworzenie public_html i pozostałych katalogów oraz umożliwienie zapisu do nich na czas instalacji procesowi serwera"
cd $INSTALL_DIR

chgrp edokumenty ~edokumenty
chmod g+w ~edokumenty

mkdir -p ~edokumenty/repos
mkdir -p ~edokumenty/repository
mkdir -p ~edokumenty/maildir
mkdir -p ~edokumenty/files
chown -R www-data:edokumenty ~edokumenty/maildir
chown -R www-data:edokumenty ~edokumenty/files
chown -R www-data:edokumenty ~edokumenty/repos
chown -R www-data:edokumenty ~edokumenty/repository
chgrp edokumenty ~edokumenty/public_html/apps/edokumenty
chmod g+w ~edokumenty/public_html/apps/edokumenty

cp lib/engine ~edokumenty/public_html/
chown edokumenty:users -R ~edokumenty/public_html

# Tworzenie użytkowników bazy danych (wszyscy z opcjami N)
echo "Tworzenie uzytkownika bazy danych - http (wszystkie opcje N)"
sudo -u postgres createuser --no-superuser --no-createdb --no-createrole http
echo "Tworzenie uzytkownika bazy danych - edokumenty (wszystkie opcje N)"
sudo -u postgres createuser --no-superuser --no-createdb --no-createrole edokumenty

# Tworzenie baz danych
echo "Tworzenie bazy edokumenty"
sudo -u postgres createdb -E UTF8 edokumenty -O edokumenty
sudo -u postgres createlang -d edokumenty plpgsql

# VPN
# cp lib/check_vpn.sh /etc/cron.hourly/

echo "Kopiowanie skryptu firewall"
cp $INSTALL_DIR'/lib/iptables.deb_rc.sh' /etc/network/

echo "Konfiguracja domyslnego backupu - domyslne skrypty, ustawienia backapu i skrypty crona"
./bin/mk_backup_dirs.sh
cd $INSTALL_DIR
cp -p $INSTALL_DIR'/lib/backup/backup_db' /etc/cron.daily/
cp -p $INSTALL_DIR'/lib/backup/backup_repos' /etc/cron.daily/
cp -p $INSTALL_DIR'/lib/backup/backup_files' /etc/cron.daily/
chmod 755 /etc/cron.daily/*

cp -p $INSTALL_DIR'/conf/exclude.conf' /etc/backup
cp -p $INSTALL_DIR'/conf/backup.conf' /etc/backup

echo "Konfiguracja czyszczenia tmp"
cp $INSTALL_DIR'/lib/delete_file_tmp' /etc/cron.daily/

# ustawienie czasu
rdate -s ntp.task.gda.pl
# hwclock --systohc

# Pakiety PEAR
pear channel-update pear.php.net
pear install Console_Getopt
pear install Auth_SASL
pear install Mail_Mime 
pear install Net_SMTP
pear install Crypt_Rc4
pear install Date
pear install HTTP_Request
pear install Mail
pear install Mail_MimeDecode
pear install Net_SMTP
pear install Net_Socket
pear install Net_URL
pear install SOAP-0.12.0
pear install OLE-0.6.1
pear install Spreadsheet_Excel_Writer-0.9.2
pear install Mail_Queue
pear install HTML_Template_Flexy


apt-get -y purge php5-suhosin
rm /etc/apache2/mods-available/php5.conf
cp -p $INSTALL_DIR'/lib/php5.conf' /etc/apache2/mods-available/

# Restart Apache i Postgres
echo "Restart apache"
sleep 3
/etc/init.d/apache2 restart


echo "Restart postgres"
sleep 1
/etc/init.d/postgresql restart


# TODO
# konfiguracja i sprawdzenie dostępu do bazy danych
# ustawienie dostępu do plików aby umożliwić zapis repository i config.inc
# najlepiej po wgraniu zip-a wykonać plik fixperms jako edokumenty
# wyłączyć katalog apps/edokumenty/var spod możliwości wykonywania skryptów php
# 


echo "Kopiowanie  FileIndexingTool"

#mkdir -p /home/edokumenty/public_html/apps/edokumenty/scripts/FileIndexingTool
#cd /home/edokumenty/public_html/apps/edokumenty/scripts/

cd  $INSTALL_DIR
mkdir  /home/edokumenty/public_html/apps/edokumenty/scripts/FileIndexingTool/
cp $INSTALL_DIR'/conf/FileIndexingTool/Run.inc'  /home/edokumenty/public_html/apps/edokumenty/scripts/FileIndexingTool/
cp $INSTALL_DIR'/conf/FileIndexingTool/FileIndex.inc'  /home/edokumenty/public_html/apps/edokumenty/scripts/FileIndexingTool/
 

echo "Modyfikuje sysctl.con dla 8GB RAM"
cp -p $INSTALL_DIR'/conf/sysctl.conf' /etc/
sysctl -p
